<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/17/2005 *
 * ===============                              Last change: 02/17/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : doubler_functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Functions for the guest's newsletter             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer den Newsletter an die Gaeste     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}
//
function DOUBLER_GENERATE_TABLE($uid="0", $done="N", $ref="N", $sort="ASC")
{
	global $CONFIG;
	if (empty($cnt)) $cnt = "0";
	$ADD = ""; $DT_MODE = "0";
	if ($uid > 0)
	{
		// Load entries only from a single user
		$ADD = " AND userid='".bigintval($uid)."'";
		$MODE = "member"; $COLS = "4"; $DT_MODE = "2";
		$NOT_FOUND = DOUBLER_MEMBER_NO_ENTRIES_FOUND;
	}
	 else
	{
		// Guest mode!
		$MODE = "guest"; $COLS = "3"; $DT_MODE = "3";
		$NOT_FOUND = DOUBLER_GUEST_NO_ENTRIES_FOUND;
	}

	if (($done == "Y") && ($sort == "ASC"))
	{
		// Already payed out points (latest payouts first)
		$limit = $CONFIG['doubler_display_old'];
	}
	 elseif ($sort == "ASC")
	{
		// List entries which will receive their payout soon
		$limit = $CONFIG['doubler_display_pay'];
	}
	 elseif ($sort == "DESC")
	{
		// Newest entries
		$limit = $CONFIG['doubler_display_new'];
	}

	// List entries
	$result = SQL_QUERY("SELECT userid, refid, points, timemark
FROM "._MYSQL_PREFIX."_doubler
WHERE completed='".$done."' AND is_ref='".$ref."'".$ADD."
ORDER BY timemark ".$sort."
LIMIT ".$limit, __FILE__, __LINE__);

	if (SQL_NUMROWS($result) > 0)
	{
		// List entries
		$OUT = ""; $SW = 2;
		while(list($uid, $rid, $points, $time) = SQL_FETCHROW($result))
		{
			if (IS_ADMIN())
			{
				// Set links to admin area
				if ($uid > 0) { $uid = ADMIN_USER_PROFILE_LINK($uid); } else { $uid = "---"; }
				if ($rid > 0) { $rid = ADMIN_USER_PROFILE_LINK($rid); } else { $rid = "---"; }
			}

			// Prepare data for the row template
			$content = array(
				'uid'    => $uid,
				'rid'    => $rid,
				'points' => TRANSLATE_COMMA($points),
				'stamp'  => MAKE_DATETIME($time, $DT_MODE),
				'sw'     => $SW,
			);

			// Load template and switch color
			$OUT .= LOAD_TEMPLATE($MODE."_doubler_list_rows", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
	}
	 else
	{
		// List no entries
		$OUT = "<TR>
  <TD colspan=\"".$COLS."\" align=\"center\" class=\"doubler_big_row bottom2\">
    ".LOAD_TEMPLATE("admin_settings_saved", true, $NOT_FOUND)."
  </TD>
</TR>\n";
	}

	// Return template
	return LOAD_TEMPLATE($MODE."_doubler_list", true, $OUT);
}
//
function DOUBLER_GET_TOTAL_POINTS_LEFT()
{
	global $CONFIG;
	// Initialize variables
	$points = "0";

	if ($CONFIG['doubler_own'] == "Y")
	{
		// Take points from doubler's own account
		$points += $CONFIG['doubler_points'] - $CONFIG['doubler_used'];
	}

	if ($CONFIG['doubler_jackpot'] == "Y")
	{
		// Load jackpot
		$result = SQL_QUERY("SELECT points FROM "._MYSQL_PREFIX."_jackpot WHERE ok='ok' LIMIT 1", __FILE__, __LINE__);
		list($jackpot) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		if (!empty($jackpot)) $points += $jackpot;
	}

	if ($CONFIG['doubler_uid'] > 0)
	{
		// Get user's points
		$user = GET_TOTAL_DATA($CONFIG['doubler_uid'], "user_points", "points");
		$points += $user;
	}

	// Return value
	return $points;
}
//
?>
