<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/05/2003 *
 * ===============                              Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-adminedit.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Edit the admin menu                              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Das Admin-Men editieren                         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2007 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

// Do we edit/delete/change main menus or sub menus?
$AND = "what=''"; $SUB = "";
if (!empty($_GET['sub']))
{
	$AND = sprintf("action='%s'", SQL_ESCAPE($_GET['sub']));
	$SUB = SQL_ESCAPE($_GET['sub']);
}

// Get count of (maybe) selected menu points
$chk = 0;
if (!empty($_POST['sel'])) $chk = SELECTION_COUNT($_POST['sel']);

OPEN_TABLE("100%", "admin_content admin_content_align", "");

// List all menu points and make them editable
OUTPUT_HTML ("<BR><BR></FONT>
<DIV align=\"center\">");
if ((isset($_POST['edit'])) && ($chk > 0) && (!IS_DEMO()))
{
	// Edit menu entries
	define('__SUB_VALUE', $SUB);
	define('__CHK_VALUE', $chk);
	$cnt = 0; $SW = 2;
	foreach ($_POST['sel'] as $sel=>$confirm)
	{
		if ($confirm == 1)
		{
			$cnt++;
			$result = SQL_QUERY_ESC("SELECT title, action, what, descr FROM "._MYSQL_PREFIX."_admin_menu WHERE ".$AND." AND id=%d LIMIT 1",
			 array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1)
			{
				// Entry found so we load the stuff...
				list($menu, $act, $wht, $descr) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);

				// Prepare data for the row template
				$content = array(
					'action' => ADMIN_MAKE_MENU_SELECTION("admin", "action", "sel_action[".$sel."]", $act),
					'what'   => ADMIN_MAKE_MENU_SELECTION("admin", "what", "sel_what[".$sel."]", $wht),
					'sw'     => $SW,
					'sel'    => $sel,
					'menu'   => $menu,
					'descr'  => $descr,
					'cnt'    => $cnt,
				);
				$OUT .= LOAD_TEMPLATE("admin_amenu_edit_row", true, $content);
			}
			 else
			{
				// Entry not found?
				$content = array(
					'sw'  => $SW,
					'sel' => $sel
				);
				$OUT .= LOAD_TEMPLATE("admin_menu_404_row", true, $content);
			}
			$SW = 3 - $SW;
		}
	}
	define('__MENU_ROWS', $OUT);
	define('__CNT_VALUE', $cnt);

	// Load template
	LOAD_TEMPLATE("admin_amenu_edit_form");
}
 elseif ((isset($_POST['del'])) && (!IS_DEMO()))
{
	define('__SUB_VALUE', $SUB);
	define('__CHK_VALUE', $chk);
	// Del menu entries with or without confirmation
	$SW = 2; $cnt = 0; $OUT = "";
	foreach ($_POST['sel'] as $sel=>$confirm)
	{
		if ($confirm == 1)
		{
			$cnt++;
			$result = SQL_QUERY_ESC("SELECT title FROM "._MYSQL_PREFIX."_admin_menu WHERE ".$AND." AND id=%d LIMIT 1",
			 array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1)
			{
				// Entry found so we load the stuff...
				list($menu) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);

				// Prepare data for the row template
				$content = array(
					'menu' => $menu,
					'cnt'  => $cnt,
					'sel'  => $sel,
					'sw'   => $SW
				);
				$OUT .= LOAD_TEMPLATE("admin_amenu_delete_row", true, $content);
			}
			 else
			{
				// Entry not found?
				$content = array(
					'sw'  => $SW,
					'sel' => $sel
				);
				$OUT .= LOAD_TEMPLATE("admin_menu_404_row", true, $content);
			}
			$SW = 3 - $SW;
		}
	}
	define('__MENU_ROWS', $OUT);
	define('__CNT_VALUE', $cnt);

	// Load template
	LOAD_TEMPLATE("admin_amenu_delete");
}
 elseif ((isset($_POST['ok'])) && (!IS_DEMO()))
{
	// An action is done...
	switch ($_POST['ok'])
	{
	case "edit": // Edit menu
		foreach ($_POST['sel'] as $sel=>$menu)
		{
			// Secure ID
			$sel = bigintval($sel);

			// Update entry
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admin_menu SET
title='%s',
action='%s',
what='%s',
descr='%s'
WHERE ".$AND." AND id=%d LIMIT 1",
 array(
	$menu,
	$_POST['sel_action'][$sel],
	$_POST['sel_what'][$sel],
	addslashes($_POST['sel_desc'][$sel]),
	$sel,
), __FILE__, __LINE__);
		}
		LOAD_TEMPLATE("admin_data_saved");
		break;

	case "del": // Delete menu
		foreach ($_POST['sel'] as $sel=>$menu)
		{
			$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE ".$AND." AND id=%d LIMIT 1",
			 array(bigintval($sel)), __FILE__, __LINE__);
		}
		LOAD_TEMPLATE("admin_data_saved");
		break;

	default: // Unexpected action
		define('__OK_VALUE', $_POST['ok']);
		LOAD_TEMPLATE("admin_menu_unknown_okay");
		break;
	}
}
 else
{
	if ((!empty($_GET['act'])) && (!empty($_GET['tid'])) && (!empty($_GET['fid'])))
	{
		// Get IDs
		if (!empty($_GET['w']))
		{
			// Sub menus selected
			$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_admin_menu WHERE action='%s' AND sort='%s' LIMIT 1",
			 array($_GET['act'], bigintval($_GET['tid'])), __FILE__, __LINE__);
			list($tid) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
			$result = SQL_QUERY("SELECT id FROM "._MYSQL_PREFIX."_admin_menu WHERE action='%s' AND sort='%s' LIMIT 1",
			 array($_GET['act'], bigintval($_GET['fid'])), __FILE__, __LINE__);
			list($fid) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
		}
		 else
		{
			// Main menu selected
			$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_admin_menu WHERE what='' AND sort='%s' LIMIT 1",
			 array(bigintval($_GET['tid'])), __FILE__, __LINE__);
			list($tid) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
			$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_admin_menu WHERE what='' AND sort='%s' LIMIT 1",
			 array(bigintval($_GET['fid'])), __FILE__, __LINE__);
			list($fid) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
		}

		if ((!empty($tid)) && (!empty($fid)))
		{
			// Sort menu
			$result_sort = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admin_menu SET sort='%s' WHERE ".$AND." AND id=%d LIMIT 1",
			 array(bigintval($_GET['tid']), bigintval($fid)), __FILE__, __LINE__);
			$result_sort = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_admin_menu SET sort='%s' WHERE ".$AND." AND id=%d LIMIT 1",
			 array(bigintval($_GET['fid']), bigintval($tid)), __FILE__, __LINE__);
		}
	}

	// By default list menus
	if (!empty($SUB))
	{
		// Sub menus of a main menu
		$result = SQL_QUERY_ESC("SELECT id, action, what, title, sort FROM "._MYSQL_PREFIX."_admin_menu WHERE action='%s' AND what != '' ORDER BY sort ASC",
		 array($SUB), __FILE__, __LINE__);
	}
	 else
	{
		// Main menus
		$result = SQL_QUERY("SELECT id, action, what, title, sort FROM "._MYSQL_PREFIX."_admin_menu WHERE what='' ORDER BY sort ASC", __FILE__, __LINE__);
	}
	$max = SQL_NUMROWS($result);
	if ($max > 0)
	{
		define('__SUB_VALUE', $SUB);
		$SW = 2; $cnt = 0; $OUT = "";
		while (list($id, $act, $wht, $title, $sort) = SQL_FETCHROW($result))
		{
			$cnt++;
			if (($sort == 0) || (($sort == 1) && (!empty($SUB))))
			{
				// Is highest position
				$NAVI = "<A href=\"".URL."/modules.php?module=admin&amp;what=adminedit&amp;sub=".$SUB."&amp;act=".$act."&amp;w=".$wht."&amp;tid=".($sort+1)."&amp;fid=".$sort."\">".LOWER."</A>";
			}
			 elseif ($cnt == $max)
			{
				// Is lowest position
				$NAVI = "<A href=\"".URL."/modules.php?module=admin&amp;what=adminedit&amp;sub=".$SUB."&amp;act=".$act."&amp;w=".$wht."&amp;tid=".($sort-1)."&amp;fid=".$sort."\">".HIGHER."</A>";
			}
			 elseif ($sort > 0)
			{
				// Anything else between highest and lowest
				$NAVI = "<A href=\"".URL."/modules.php?module=admin&amp;what=adminedit&amp;sub=".$SUB."&amp;act=".$act."&amp;w=".$wht."&amp;tid=".($sort-1)."&amp;fid=".$sort."\">".HIGHER."</A>/<A href=\"".URL."/modules.php?module=admin&amp;what=adminedit&amp;sub=".$SUB."&amp;act=".$act."&amp;w=".$wht."&amp;tid=".($sort+1)."&amp;fid=".$sort."\">".LOWER."</A>";
			}

			if (empty($act)) $act = "&nbsp;";
			if (empty($wht))   $wht   = "&nbsp;";
			if (empty($title))  $title  = "&nbsp;";

			$content = array(
				'sw'     => $SW,
				'id'     => $id,
				'action' => $act,
				'what'   => $wht,
				'title'  => $title,
				'navi'   => $NAVI,
				'mode'   => "admin",
			);
			$OUT .= LOAD_TEMPLATE("admin_menu_overview_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
		define('__MENU_ROWS', $OUT);

		// Load template
		LOAD_TEMPLATE("admin_amenu_edit");
	}
	 else
	{
		// Menu entries are missing... (???)
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_NO_MENUS_FOUND);
	}
}
OUTPUT_HTML ("</DIV>");
CLOSE_TABLE();
//
?>
